%% fscanf
fid=fopen('gradelist.txt');
header = fgetl(fid);
names=[];
grades=[];
while ~feof(fid)
    name = fscanf(fid,'%s,');
    grade = fscanf(fid,'%f, %f, %f,');
    names{end+1} = name;
    grades(end+1,:) = grade;
end
fclose(fid);

%% textscan
fid=fopen('gradelist.txt')
header = fgetl(fid)
data=textscan(fid,'%s %f %f %f','Delimiter',',')
fclose(fid);

%% indirect function evaluations
x=[0 pi];
y=cos(x)
z=feval('cos',x)
plotFunc('cos',[0 pi]);

%% inline functions
f=inline('cos(x).*sin(x)')
f(x)

%% derivative
x=linspace(0,pi,50);
y=sin(x);
dydx=diff(y)./diff(x);
dydxCD=(dydx([1 1:end])+dydx([1:end end]))/2;
plot(x,y)
hold on
plot(x(2:end),dydx,'r')
plot(x(1:end-1),dydx,'g')
plot(x,cos(x),'k')
plot(x,dydxCD,'c')
hold off
y=trapz(x,y)

%% quadrature
F = quad('cos(x)',0,2*pi)
f=inline('sin(x)');
F = quad(f,0,pi,1e-2)

%% function handles
f=@(x)cos(x)
f(x)

%% ode
f=inline('x*y^2+y')
options=odeset('RelTol',1e-10)
[x,y]=ode45(f,0:0.05:0.5,1,options);
plot(x,y,'.-')

%% ode system
x0=[-8 8 27];
tspan=[0,20];
[t,xyz]=ode45(@lorenz,tspan,x0);

%% symbolic toolbox
syms x real
y=cos(x)
diff(y,x)
int(y,x)
subs(y,x,pi/3)
limit(sin(x)/x,x,0)
ezplot(sin(x))
