%% fscanf
fid=fopen('gradelist.txt')
header = fgetl(fid)
names=[];
grades=[];
while ~feof(fid)
    name = fscanf(fid,'%s,')
    grade = fscanf(fid,'%f, %f, %f,')
    names{end+1} = name;
    grades(end+1,:) = grade;
end
fclose(fid);

%% textscan
fid=fopen('gradelist.txt')
header = fgetl(fid)
data=textscan(fid,'%s %f %f %f','Delimiter',',')
fclose(fid);

%% indirect function evaluations
x=[0 pi];
y=cos(x)
z=feval('cos',x)
plotFunc('cos',[0 pi]);

%% inline functions
f=inline('cos(x)')
f(x)

%% quadrature
F = quad('cos(x)',0,2*pi)
F = quad(f,0,2*pi)

%% function handles
f=@(x)cos(x)
f(x)

%% ode
f=inline('x*y^2+y')
[x,y]=ode45(f,[0 0.5],1);
plot(x,y)

%% symbolic toolbox
syms x real
y=cos(x)
diff(y,x)
int(y,x)
subs(y,x,pi/3)
