function solveSudoku(sol)
    %initialize pos
    %exclude values that already exist in the row/column/box
    pos=true(9,9,9);
    for row=1:9
    for col=1:9
        num=sol(row,col);
        if (num==0); 
            continue; 
        end
        %set the possibility of all values for position (row,col) to false
        pos(row,col,:)=false;
        %set the possibility of num in the row to false
        pos(row,:,num)=false;
        %set the possibility of num in the column to false
        pos(:,col,num)=false;
        %set the possibility of num in the box to false
        pos(row-mod(row-1,3)+[0 1 2],col-mod(col-1,3)+[0 1 2],num)=false;
    end
    end
    
    %initialize nPos
    nPos=sum(pos,3);
    nPos(logical(sol))=0;
    
    %check for new discoveries (i.e. where nPos==1)
    [rows,cols]=find(nPos==1);
    %update sol and pos based on the newly discovered values, 
    %then check for new discoveries
    while (~isempty(rows))
        %uncomment the next line to see the updating grid
        %plotSudoku(sol,nPos,pos,rows,cols);
        
        for i=1:length(rows)
            row=rows(i);
            col=cols(i);
            %enter the newly discovered value into sol
            num=find(pos(row,col,:));
            sol(row,col)=num;
            %set the possibility of num in the row to false and update nPos
            nPos(row,pos(row,:,num))=nPos(row,pos(row,:,num))-1;
            pos(row,:,num)=false;
            %set the possibility of num in the col to false and update nPos
            nPos(pos(:,col,num),col)=nPos(pos(:,col,num),col)-1;
            pos(:,col,num)=false;
            %set the possibility of num in the box to false and update nPos
            r=row-mod(row-1,3)+[0 1 2];
            c=col-mod(col-1,3)+[0 1 2];
            nPos(r,c)=nPos(r,c)-pos(r,c,num);
            pos(r,c,num)=false;
        end
        %check for new discoveries
        [rows,cols]=find(nPos==1);
    end
return